/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-15 at 20:51:54 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.orkut.model;

/**
 * Model definition for CommunityMessage.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Orkut API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CommunityMessage extends com.google.api.client.json.GenericJson {

  /**
   * The timestamp of the date when the message was added, in RFC 3339 format.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime addedDate;

  /**
   * The creator of the message. If ommited, the message is annonimous.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private OrkutAuthorResource author;

  /**
   * The body of the message.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String body;

  /**
   * The ID of the message.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long id;

  /**
   * Whether this post was marked as spam by the viewer, when he/she is not the community owner or
   * one of its moderators.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isSpam;

  /**
   * Identifies this resource as a community message. Value: "orkut#communityMessage"
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * List of resources for the community message.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<OrkutLinkResource> links;

  static {
    // hack to force ProGuard to consider OrkutLinkResource used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(OrkutLinkResource.class);
  }

  /**
   * The subject of the message.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String subject;

  /**
   * The timestamp of the date when the message was added, in RFC 3339 format.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getAddedDate() {
    return addedDate;
  }

  /**
   * The timestamp of the date when the message was added, in RFC 3339 format.
   * @param addedDate addedDate or {@code null} for none
   */
  public CommunityMessage setAddedDate(com.google.api.client.util.DateTime addedDate) {
    this.addedDate = addedDate;
    return this;
  }

  /**
   * The creator of the message. If ommited, the message is annonimous.
   * @return value or {@code null} for none
   */
  public OrkutAuthorResource getAuthor() {
    return author;
  }

  /**
   * The creator of the message. If ommited, the message is annonimous.
   * @param author author or {@code null} for none
   */
  public CommunityMessage setAuthor(OrkutAuthorResource author) {
    this.author = author;
    return this;
  }

  /**
   * The body of the message.
   * @return value or {@code null} for none
   */
  public java.lang.String getBody() {
    return body;
  }

  /**
   * The body of the message.
   * @param body body or {@code null} for none
   */
  public CommunityMessage setBody(java.lang.String body) {
    this.body = body;
    return this;
  }

  /**
   * The ID of the message.
   * @return value or {@code null} for none
   */
  public java.lang.Long getId() {
    return id;
  }

  /**
   * The ID of the message.
   * @param id id or {@code null} for none
   */
  public CommunityMessage setId(java.lang.Long id) {
    this.id = id;
    return this;
  }

  /**
   * Whether this post was marked as spam by the viewer, when he/she is not the community owner or
   * one of its moderators.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsSpam() {
    return isSpam;
  }

  /**
   * Whether this post was marked as spam by the viewer, when he/she is not the community owner or
   * one of its moderators.
   * @param isSpam isSpam or {@code null} for none
   */
  public CommunityMessage setIsSpam(java.lang.Boolean isSpam) {
    this.isSpam = isSpam;
    return this;
  }

  /**
   * Identifies this resource as a community message. Value: "orkut#communityMessage"
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies this resource as a community message. Value: "orkut#communityMessage"
   * @param kind kind or {@code null} for none
   */
  public CommunityMessage setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * List of resources for the community message.
   * @return value or {@code null} for none
   */
  public java.util.List<OrkutLinkResource> getLinks() {
    return links;
  }

  /**
   * List of resources for the community message.
   * @param links links or {@code null} for none
   */
  public CommunityMessage setLinks(java.util.List<OrkutLinkResource> links) {
    this.links = links;
    return this;
  }

  /**
   * The subject of the message.
   * @return value or {@code null} for none
   */
  public java.lang.String getSubject() {
    return subject;
  }

  /**
   * The subject of the message.
   * @param subject subject or {@code null} for none
   */
  public CommunityMessage setSubject(java.lang.String subject) {
    this.subject = subject;
    return this;
  }

  @Override
  public CommunityMessage set(String fieldName, Object value) {
    return (CommunityMessage) super.set(fieldName, value);
  }

  @Override
  public CommunityMessage clone() {
    return (CommunityMessage) super.clone();
  }

}
